/*
 * md4_sse2.c
 *
 * hashkill - a hash cracking tool
 * Copyright (C) 2010 Milen Rangelov <gat3way@gat3way.eu>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#ifdef HAVE_SSE2

#include <emmintrin.h>
#include <mmintrin.h>
#include <xmmintrin.h>

#include "md4_sse2.h"

void MD4_SSE(char *plains[8], char *hash[8], int lens[8])
{

    __m128i w0, w1, w2, w3, w4, w5, w6, w7, w14;
    __m128i w01, w11, w21, w31, w41, w51, w61, w71, w141;
    __m128i w02, w12, w22, w32, w42, w52, w62, w72, w142;
    __m128i w03, w13, w23, w33, w43, w53, w63, w73, w143;


    __m128i a, b, c, d, AC, AD;
    __m128i a2, b2, c2, d2, tmp1, tmp2, tmp1_2, tmp2_2, tmp1_3, tmp2_3, tmp1_4, tmp2_4;
    __m128i a3, b3, c3, d3 ;
    __m128i a4, b4, c4, d4 ;

    __m128i A,B,C,D;
    int i;


#define udata1 ((UINT4 *)plains[0])
#define udata2 ((UINT4 *)plains[1])
#define udata3 ((UINT4 *)plains[2])
#define udata4 ((UINT4 *)plains[3])
#define udata5 ((UINT4 *)plains[4])
#define udata6 ((UINT4 *)plains[5])
#define udata7 ((UINT4 *)plains[6])
#define udata8 ((UINT4 *)plains[7])
#define udata9 ((UINT4 *)plains[0])
#define udata10 ((UINT4 *)plains[1])
#define udata11 ((UINT4 *)plains[2])
#define udata12 ((UINT4 *)plains[3])
#define udata13 ((UINT4 *)plains[4])
#define udata14 ((UINT4 *)plains[5])
#define udata15 ((UINT4 *)plains[6])
#define udata16 ((UINT4 *)plains[7])



#define _mm_extract_epi32(x, imm) \
        _mm_cvtsi128_si32(_mm_srli_si128((x), 4 * (imm)))


    AC = _mm_set1_epi32(0x5a827999);
    AD = _mm_set1_epi32(0x6ed9eba1);

    for (i = 0; i < 16; i++)
    {
	plains[i][lens[i]]=0x80;
    }

    w0 = _mm_set_epi32(udata1[0],udata2[0],udata3[0],udata4[0]);
    w01 = _mm_set_epi32(udata5[0],udata6[0],udata7[0],udata8[0]);
    w02 = _mm_set_epi32(udata9[0],udata10[0],udata11[0],udata12[0]);
    w03 = _mm_set_epi32(udata13[0],udata14[0],udata15[0],udata16[0]);
    w1 = _mm_set_epi32(udata1[1],udata2[1],udata3[1],udata4[1]);
    w11 = _mm_set_epi32(udata5[1],udata6[1],udata7[1],udata8[1]);
    w12 = _mm_set_epi32(udata9[1],udata10[1],udata11[1],udata12[1]);
    w13 = _mm_set_epi32(udata13[1],udata14[1],udata15[1],udata16[1]);
    w2 = _mm_set_epi32(udata1[2],udata2[2],udata3[2],udata7[2]);
    w21 = _mm_set_epi32(udata5[2],udata6[2],udata7[2],udata8[2]);
    w22 = _mm_set_epi32(udata9[2],udata10[2],udata11[2],udata12[2]);
    w23 = _mm_set_epi32(udata13[2],udata14[2],udata15[2],udata16[2]);
    w3 = _mm_set_epi32(udata1[3],udata2[3],udata3[3],udata7[3]);
    w31 = _mm_set_epi32(udata5[3],udata6[3],udata7[3],udata8[3]);
    w32 = _mm_set_epi32(udata9[3],udata10[3],udata11[3],udata12[3]);
    w33 = _mm_set_epi32(udata13[3],udata14[3],udata15[3],udata16[3]);
    w4 = _mm_set_epi32(udata1[4],udata2[4],udata3[4],udata7[4]);
    w41 = _mm_set_epi32(udata5[4],udata6[4],udata7[4],udata8[4]);
    w42 = _mm_set_epi32(udata9[4],udata10[4],udata11[4],udata12[4]);
    w43 = _mm_set_epi32(udata13[4],udata14[4],udata15[4],udata16[4]);
    w5 = _mm_set_epi32(udata1[5],udata2[5],udata3[5],udata7[5]);
    w51 = _mm_set_epi32(udata5[5],udata6[5],udata7[5],udata8[5]);
    w52 = _mm_set_epi32(udata9[5],udata10[5],udata11[5],udata12[5]);
    w53 = _mm_set_epi32(udata13[5],udata14[5],udata15[5],udata16[5]);
    w6 = _mm_set_epi32(udata1[6],udata2[6],udata3[6],udata7[6]);
    w61 = _mm_set_epi32(udata5[6],udata6[6],udata7[6],udata8[6]);
    w62 = _mm_set_epi32(udata9[6],udata10[6],udata11[6],udata12[6]);
    w63 = _mm_set_epi32(udata13[6],udata14[6],udata15[6],udata16[6]);
    w7 = _mm_set_epi32(udata1[7],udata2[7],udata3[7],udata7[7]);
    w71 = _mm_set_epi32(udata5[7],udata6[7],udata7[7],udata8[7]);
    w72 = _mm_set_epi32(udata9[7],udata10[7],udata11[7],udata12[7]);
    w73 = _mm_set_epi32(udata13[7],udata14[7],udata15[7],udata16[7]);
    w14 = _mm_set_epi32(lens[0]*8,lens[1]*8,lens[2]*8,lens[3]*8);
    w141 = _mm_set_epi32(lens[4]*8,lens[5]*8,lens[6]*8,lens[7]*8);
    w142 = _mm_set_epi32(lens[8]*8,lens[9]*8,lens[10]*8,lens[11]*8);
    w143 = _mm_set_epi32(lens[12]*8,lens[13]*8,lens[14]*8,lens[15]*8);

    a = _mm_set1_epi32(Ca);
    a2 = _mm_set1_epi32(Ca);
    a3 = _mm_set1_epi32(Ca);
    a4 = _mm_set1_epi32(Ca);
    b = _mm_set1_epi32(Cb); 
    b2 = _mm_set1_epi32(Cb);
    b3 = _mm_set1_epi32(Cb);
    b4 = _mm_set1_epi32(Cb);
    c = _mm_set1_epi32(Cc); 
    c2 = _mm_set1_epi32(Cc);
    c3 = _mm_set1_epi32(Cc);
    c4 = _mm_set1_epi32(Cc);
    d = _mm_set1_epi32(Cd); 
    d2 = _mm_set1_epi32(Cd);
    d3 = _mm_set1_epi32(Cd);
    d4 = _mm_set1_epi32(Cd);
    A = _mm_set1_epi32(Ca);
    B = _mm_set1_epi32(Cb); 
    C = _mm_set1_epi32(Cc); 
    D = _mm_set1_epi32(Cd); 

    MD4_STEPS();
    a = _mm_add_epi32(a,A);
    b = _mm_add_epi32(b,B);
    c = _mm_add_epi32(c,C);
    d = _mm_add_epi32(d,D);
    a2 = _mm_add_epi32(a2,A);
    b2 = _mm_add_epi32(b2,B);
    c2 = _mm_add_epi32(c2,C);
    d2 = _mm_add_epi32(d2,D);
    a3 = _mm_add_epi32(a3,A);
    b3 = _mm_add_epi32(b3,B);
    c3 = _mm_add_epi32(c3,C);
    d3 = _mm_add_epi32(d3,D);
    a4 = _mm_add_epi32(a4,A);
    b4 = _mm_add_epi32(b4,B);
    c4 = _mm_add_epi32(c4,C);
    d4 = _mm_add_epi32(d4,D);


#define udigest1 ((UINT4 *)hash[0])
#define udigest2 ((UINT4 *)hash[1])
#define udigest3 ((UINT4 *)hash[2])
#define udigest4 ((UINT4 *)hash[3])
#define udigest5 ((UINT4 *)hash[4])
#define udigest6 ((UINT4 *)hash[5])
#define udigest7 ((UINT4 *)hash[6])
#define udigest8 ((UINT4 *)hash[7])
#define udigest9 ((UINT4 *)hash[8])
#define udigest10 ((UINT4 *)hash[9])
#define udigest11 ((UINT4 *)hash[10])
#define udigest12 ((UINT4 *)hash[11])
#define udigest13 ((UINT4 *)hash[12])
#define udigest14 ((UINT4 *)hash[13])
#define udigest15 ((UINT4 *)hash[14])
#define udigest16 ((UINT4 *)hash[15])


    udigest4[0] = _mm_extract_epi32(a, 0);
    udigest4[1] = _mm_extract_epi32(b, 0);
    udigest4[2] = _mm_extract_epi32(c, 0);
    udigest4[3] = _mm_extract_epi32(d, 0);
    udigest3[0] = _mm_extract_epi32(a, 1);
    udigest3[1] = _mm_extract_epi32(b, 1);
    udigest3[2] = _mm_extract_epi32(c, 1);
    udigest3[3] = _mm_extract_epi32(d, 1);
    udigest2[0] = _mm_extract_epi32(a, 2);
    udigest2[1] = _mm_extract_epi32(b, 2);
    udigest2[2] = _mm_extract_epi32(c, 2);
    udigest2[3] = _mm_extract_epi32(d, 2);
    udigest1[0] = _mm_extract_epi32(a, 3);
    udigest1[1] = _mm_extract_epi32(b, 3);
    udigest1[2] = _mm_extract_epi32(c, 3);
    udigest1[3] = _mm_extract_epi32(d, 3);
    udigest8[0] = _mm_extract_epi32(a2, 0);
    udigest8[1] = _mm_extract_epi32(b2, 0);
    udigest8[2] = _mm_extract_epi32(c2, 0);
    udigest8[3] = _mm_extract_epi32(d2, 0);
    udigest7[0] = _mm_extract_epi32(a2, 1);
    udigest7[1] = _mm_extract_epi32(b2, 1);
    udigest7[2] = _mm_extract_epi32(c2, 1);
    udigest7[3] = _mm_extract_epi32(d2, 1);
    udigest6[0] = _mm_extract_epi32(a2, 2);
    udigest6[1] = _mm_extract_epi32(b2, 2);
    udigest6[2] = _mm_extract_epi32(c2, 2);
    udigest6[3] = _mm_extract_epi32(d2, 2);
    udigest5[0] = _mm_extract_epi32(a2, 3);
    udigest5[1] = _mm_extract_epi32(b2, 3);
    udigest5[2] = _mm_extract_epi32(c2, 3);
    udigest5[3] = _mm_extract_epi32(d2, 3);



    udigest12[0] = _mm_extract_epi32(a3, 0);
    udigest12[1] = _mm_extract_epi32(b3, 0);
    udigest12[2] = _mm_extract_epi32(c3, 0);
    udigest12[3] = _mm_extract_epi32(d3, 0);
    udigest11[0] = _mm_extract_epi32(a3, 1);
    udigest11[1] = _mm_extract_epi32(b3, 1);
    udigest11[2] = _mm_extract_epi32(c3, 1);
    udigest11[3] = _mm_extract_epi32(d3, 1);
    udigest10[0] = _mm_extract_epi32(a3, 2);
    udigest10[1] = _mm_extract_epi32(b3, 2);
    udigest10[2] = _mm_extract_epi32(c3, 2);
    udigest10[3] = _mm_extract_epi32(d3, 2);
    udigest9[0] = _mm_extract_epi32(a3, 3);
    udigest9[1] = _mm_extract_epi32(b3, 3);
    udigest9[2] = _mm_extract_epi32(c3, 3);
    udigest9[3] = _mm_extract_epi32(d3, 3);
    udigest16[0] = _mm_extract_epi32(a4, 0);
    udigest16[1] = _mm_extract_epi32(b4, 0);
    udigest16[2] = _mm_extract_epi32(c4, 0);
    udigest16[3] = _mm_extract_epi32(d4, 0);
    udigest15[0] = _mm_extract_epi32(a4, 1);
    udigest15[1] = _mm_extract_epi32(b4, 1);
    udigest15[2] = _mm_extract_epi32(c4, 1);
    udigest15[3] = _mm_extract_epi32(d4, 1);
    udigest14[0] = _mm_extract_epi32(a4, 2);
    udigest14[1] = _mm_extract_epi32(b4, 2);
    udigest14[2] = _mm_extract_epi32(c4, 2);
    udigest14[3] = _mm_extract_epi32(d4, 2);
    udigest13[0] = _mm_extract_epi32(a4, 3);
    udigest13[1] = _mm_extract_epi32(b4, 3);
    udigest13[2] = _mm_extract_epi32(c4, 3);
    udigest13[3] = _mm_extract_epi32(d4, 3);


    for (i = 0; i < 16; i++)
    {
	*(plains[i]+lens[i])=0x0;
    }

}
#endif
