/*
 * md5_sse2.c
 *
 * hashkill - a hash cracking tool
 * Copyright (C) 2010 Milen Rangelov <gat3way@gat3way.eu>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


// (C) Daniel Niggebrugge
// feel free to use in other open source code, no garantuees, etc
//

#ifdef HAVE_SSE2

#define SSE_SIMULTANEOUS 16


#include <xmmintrin.h>
#include "md5_sse2.h"

void MD5_SSE(unsigned char* pPlain[SSE_SIMULTANEOUS], int nPlainLen[SSE_SIMULTANEOUS], unsigned char* pHash[SSE_SIMULTANEOUS])
{
    __m128i mAC1 = _mm_set1_epi32(0xd76aa478);
    __m128i mAC2 = _mm_set1_epi32(0xe8c7b756);
    __m128i mAC3 = _mm_set1_epi32(0x242070db);
    __m128i mAC4 = _mm_set1_epi32(0xc1bdceee);
    __m128i mAC5 = _mm_set1_epi32(0xf57c0faf);
    __m128i mAC6 = _mm_set1_epi32(0x4787c62a);
    __m128i mAC7 = _mm_set1_epi32(0xa8304613);
    __m128i mAC8 = _mm_set1_epi32(0xfd469501);
    __m128i mAC9 = _mm_set1_epi32(0x698098d8);
    __m128i mAC10 = _mm_set1_epi32(0x8b44f7af);
    __m128i mAC11 = _mm_set1_epi32(0xffff5bb1);
    __m128i mAC12 = _mm_set1_epi32(0x895cd7be);
    __m128i mAC13 = _mm_set1_epi32(0x6b901122);
    __m128i mAC14 = _mm_set1_epi32(0xfd987193);
    __m128i mAC15 = _mm_set1_epi32(0xa679438e);
    __m128i mAC16 = _mm_set1_epi32(0x49b40821);
    __m128i mAC17 = _mm_set1_epi32(0xf61e2562);
    __m128i mAC18 = _mm_set1_epi32(0xc040b340);
    __m128i mAC19 = _mm_set1_epi32(0x265e5a51);
    __m128i mAC20 = _mm_set1_epi32(0xe9b6c7aa);
    __m128i mAC21 = _mm_set1_epi32(0xd62f105d);
    __m128i mAC22 = _mm_set1_epi32(0x02441453);
    __m128i mAC23 = _mm_set1_epi32(0xd8a1e681);
    __m128i mAC24 = _mm_set1_epi32(0xe7d3fbc8);
    __m128i mAC25 = _mm_set1_epi32(0x21e1cde6);
    __m128i mAC26 = _mm_set1_epi32(0xc33707d6);
    __m128i mAC27 = _mm_set1_epi32(0xf4d50d87);
    __m128i mAC28 = _mm_set1_epi32(0x455a14ed);
    __m128i mAC29 = _mm_set1_epi32(0xa9e3e905);
    __m128i mAC30 = _mm_set1_epi32(0xfcefa3f8);
    __m128i mAC31 = _mm_set1_epi32(0x676f02d9);
    __m128i mAC32 = _mm_set1_epi32(0x8d2a4c8a);
    __m128i mAC33 = _mm_set1_epi32(0xfffa3942);
    __m128i mAC34 = _mm_set1_epi32(0x8771f681);
    __m128i mAC35 = _mm_set1_epi32(0x6d9d6122);
    __m128i mAC36 = _mm_set1_epi32(0xfde5380c);
    __m128i mAC37 = _mm_set1_epi32(0xa4beea44);
    __m128i mAC38 = _mm_set1_epi32(0x4bdecfa9);
    __m128i mAC39 = _mm_set1_epi32(0xf6bb4b60);
    __m128i mAC40 = _mm_set1_epi32(0xbebfbc70);
    __m128i mAC41 = _mm_set1_epi32(0x289b7ec6);
    __m128i mAC42 = _mm_set1_epi32(0xeaa127fa);
    __m128i mAC43 = _mm_set1_epi32(0xd4ef3085);
    __m128i mAC44 = _mm_set1_epi32(0x04881d05);
    __m128i mAC45 = _mm_set1_epi32(0xd9d4d039);
    __m128i mAC46 = _mm_set1_epi32(0xe6db99e5);
    __m128i mAC47 = _mm_set1_epi32(0x1fa27cf8);
    __m128i mAC48 = _mm_set1_epi32(0xc4ac5665);
    __m128i mAC49 = _mm_set1_epi32(0xf4292244);
    __m128i mAC50 = _mm_set1_epi32(0x432aff97);
    __m128i mAC51 = _mm_set1_epi32(0xab9423a7);
    __m128i mAC52 = _mm_set1_epi32(0xfc93a039);
    __m128i mAC53 = _mm_set1_epi32(0x655b59c3);
    __m128i mAC54 = _mm_set1_epi32(0x8f0ccc92);
    __m128i mAC55 = _mm_set1_epi32(0xffeff47d);
    __m128i mAC56 = _mm_set1_epi32(0x85845dd1);
    __m128i mAC57 = _mm_set1_epi32(0x6fa87e4f);
    __m128i mAC58 = _mm_set1_epi32(0xfe2ce6e0);
    __m128i mAC59 = _mm_set1_epi32(0xa3014314);
    __m128i mAC60 = _mm_set1_epi32(0x4e0811a1);
    __m128i mAC61 = _mm_set1_epi32(0xf7537e82);
    __m128i mAC62 = _mm_set1_epi32(0xbd3af235);
    __m128i mAC63 = _mm_set1_epi32(0x2ad7d2bb);
    __m128i mAC64 = _mm_set1_epi32(0xeb86d391);

    __m128i mOne = _mm_set1_epi32(0xFFFFFFFF);

    __m128i mCa = _mm_set1_epi32(Ca);
    __m128i mCb = _mm_set1_epi32(Cb);
    __m128i mCc = _mm_set1_epi32(Cc);
    __m128i mCd = _mm_set1_epi32(Cd);


    __m128i w0_1, w0_2, w0_3, w1_1, w1_2, w1_3, w2_1, w2_2, w2_3, w3_1, w3_2, w3_3, w14_1, w14_2, w14_3;
    __m128i w4_1, w4_2, w4_3, w5_1, w5_2, w5_3, w6_1, w6_2, w6_3, w7_1, w7_2, w7_3;
    __m128i w8_1, w8_2, w8_3, w9_1, w9_2, w9_3, w10_1, w10_2, w10_3;
    __m128i w0_4, w1_4, w2_4, w3_4, w4_4, w5_4, w6_4, w7_4, w8_4, w9_4, w10_4, w14_4;

    __m128i a, b, c, d, tmp1;
    __m128i a2, b2, c2, d2, tmp1_2;
    __m128i a3, b3, c3, d3, tmp1_3;
    __m128i a4, b4, c4, d4, tmp1_4;


    int i;
    char *tst;
    for (i = 0; i < SSE_SIMULTANEOUS; i++)
    {
	*(pPlain[i]+nPlainLen[i])=0x80;
    }


#define uData ((UINT4 *)pPlain)
#define udata1 ((UINT4 *)pPlain[0])
#define udata2 ((UINT4 *)pPlain[1])
#define udata3 ((UINT4 *)pPlain[2])
#define udata4 ((UINT4 *)pPlain[3])
#define udata5 ((UINT4 *)pPlain[4])
#define udata6 ((UINT4 *)pPlain[5])
#define udata7 ((UINT4 *)pPlain[6])
#define udata8 ((UINT4 *)pPlain[7])
#define udata9 ((UINT4 *)pPlain[8])
#define udata10 ((UINT4 *)pPlain[9])
#define udata11 ((UINT4 *)pPlain[10])
#define udata12 ((UINT4 *)pPlain[11])
#define udata13 ((UINT4 *)pPlain[12])
#define udata14 ((UINT4 *)pPlain[13])
#define udata15 ((UINT4 *)pPlain[14])
#define udata16 ((UINT4 *)pPlain[15])




#define NEXT_PLAIN (MAX_PLAIN_LEN/4)

    w0_1 = _mm_set_epi32(udata1[0], udata2[0], udata3[0], udata4[0]);
    w0_2 = _mm_set_epi32(udata5[0], udata6[0], udata7[0], udata8[0]);
    w0_3 = _mm_set_epi32(udata9[0], udata10[0], udata11[0], udata12[0]);
    w0_4 = _mm_set_epi32(udata13[0], udata14[0], udata15[0], udata16[0]);

    w1_1 = _mm_set_epi32(udata1[1], udata2[1], udata3[1], udata4[1]);
    w1_2 = _mm_set_epi32(udata5[1], udata6[1], udata7[1], udata8[1]);
    w1_3 = _mm_set_epi32(udata9[1], udata10[1], udata11[1], udata12[1]);
    w1_4 = _mm_set_epi32(udata13[1], udata14[1], udata15[1], udata16[1]);

    w2_1 = _mm_set_epi32(udata1[2], udata2[2], udata3[2], udata4[2]);
    w2_2 = _mm_set_epi32(udata5[2], udata6[2], udata7[2], udata8[2]);
    w2_3 = _mm_set_epi32(udata9[2], udata10[2], udata11[2], udata12[2]);
    w2_4 = _mm_set_epi32(udata13[2], udata14[2], udata15[2], udata16[2]);

    w3_1 = _mm_set_epi32(udata1[3], udata2[3], udata3[3], udata4[3]);
    w3_2 = _mm_set_epi32(udata5[3], udata6[3], udata7[3], udata8[3]);
    w3_3 = _mm_set_epi32(udata9[3], udata10[3], udata11[3], udata12[3]);
    w3_4 = _mm_set_epi32(udata13[3], udata14[3], udata15[3], udata16[3]);

    w4_1 = _mm_set_epi32(udata1[4], udata2[4], udata3[4], udata4[4]);
    w4_2 = _mm_set_epi32(udata5[4], udata6[4], udata7[4], udata8[4]);
    w4_3 = _mm_set_epi32(udata9[4], udata10[4], udata11[4], udata12[4]);
    w4_4 = _mm_set_epi32(udata13[4], udata14[4], udata15[4], udata16[4]);

    w5_1 = _mm_set_epi32(udata1[5], udata2[5], udata3[5], udata4[5]);
    w5_2 = _mm_set_epi32(udata5[5], udata6[5], udata7[5], udata8[5]);
    w5_3 = _mm_set_epi32(udata9[5], udata10[5], udata11[5], udata12[5]);
    w5_4 = _mm_set_epi32(udata13[5], udata14[5], udata15[5], udata16[5]);

    w6_1 = _mm_set_epi32(udata1[6], udata2[6], udata3[6], udata4[6]);
    w6_2 = _mm_set_epi32(udata5[6], udata6[6], udata7[6], udata8[6]);
    w6_3 = _mm_set_epi32(udata9[6], udata10[6], udata11[6], udata12[6]);
    w6_4 = _mm_set_epi32(udata13[6], udata14[6], udata15[6], udata16[6]);

    w7_1 = _mm_set_epi32(udata1[7], udata2[7], udata3[7], udata4[7]);
    w7_2 = _mm_set_epi32(udata5[7], udata6[7], udata7[7], udata8[7]);
    w7_3 = _mm_set_epi32(udata9[7], udata10[7], udata11[7], udata12[7]);
    w7_4 = _mm_set_epi32(udata13[7], udata14[7], udata15[7], udata16[7]);

    w8_1 = _mm_set_epi32(udata1[8], udata2[8], udata3[8], udata4[8]);
    w8_2 = _mm_set_epi32(udata5[8], udata6[8], udata7[8], udata8[8]);
    w8_3 = _mm_set_epi32(udata9[8], udata10[8], udata11[8], udata12[8]);
    w8_4 = _mm_set_epi32(udata13[8], udata14[8], udata15[8], udata16[8]);

    w9_1 = _mm_set_epi32(udata1[9], udata2[9], udata3[9], udata4[9]);
    w9_2 = _mm_set_epi32(udata5[9], udata6[9], udata7[9], udata8[9]);
    w9_3 = _mm_set_epi32(udata9[9], udata10[9], udata11[9], udata12[9]);
    w9_4 = _mm_set_epi32(udata13[9], udata14[9], udata15[9], udata16[9]);

    w10_1 = _mm_set_epi32(udata1[10], udata2[10], udata3[10], udata4[10]);
    w10_2 = _mm_set_epi32(udata5[10], udata6[10], udata7[10], udata8[10]);
    w10_3 = _mm_set_epi32(udata9[10], udata10[10], udata11[10], udata12[10]);
    w10_4 = _mm_set_epi32(udata13[10], udata14[10], udata15[10], udata16[10]);

    w14_1 = _mm_set_epi32(nPlainLen[0]*8, nPlainLen[1]*8, nPlainLen[2]*8, nPlainLen[3]*8);
    w14_2 = _mm_set_epi32(nPlainLen[4]*8, nPlainLen[5]*8, nPlainLen[6]*8, nPlainLen[7]*8);
    w14_3 = _mm_set_epi32(nPlainLen[8]*8, nPlainLen[9]*8, nPlainLen[10]*8, nPlainLen[11]*8);
    w14_4 = _mm_set_epi32(nPlainLen[12]*8, nPlainLen[13]*8, nPlainLen[14]*8, nPlainLen[15]*8);

    a = mCa;
    a2 = mCa;
    a3 = mCa;
    a4 = mCa;

    b = mCb;
    b2 = mCb;
    b3 = mCb;
    b4 = mCb;

    c = mCc;
    c2 = mCc;
    c3 = mCc;
    c4 = mCc;

    d = mCd;
    d2 = mCd;
    d3 = mCd;
    d4 = mCd;

    MD5_STEPS();

    a = _mm_add_epi32(a,mCa);
    a2 =  _mm_add_epi32(a2,mCa);
    a3 =  _mm_add_epi32(a3,mCa);
    a4 =  _mm_add_epi32(a4,mCa);

    b =  _mm_add_epi32(b,mCb);
    b2 = _mm_add_epi32(b2,mCb);
    b3 = _mm_add_epi32(b3,mCb);
    b4 = _mm_add_epi32(b4,mCb);

    c =  _mm_add_epi32(c,mCc);
    c2 = _mm_add_epi32(c2,mCc);
    c3 =  _mm_add_epi32(c3,mCc);
    c4 =  _mm_add_epi32(c4,mCc);

    d =  _mm_add_epi32(d,mCd);
    d2 =  _mm_add_epi32(d2,mCd);
    d3 =  _mm_add_epi32(d3,mCd);
    d4 =  _mm_add_epi32(d4,mCd);

#define uDigest ((UINT4 *)pHash)
#define NEXT_HASH (MAX_HASH_LEN/4)
#define udigest1 ((UINT4 *)pHash[0])
#define udigest2 ((UINT4 *)pHash[1])
#define udigest3 ((UINT4 *)pHash[2])
#define udigest4 ((UINT4 *)pHash[3])
#define udigest5 ((UINT4 *)pHash[4])
#define udigest6 ((UINT4 *)pHash[5])
#define udigest7 ((UINT4 *)pHash[6])
#define udigest8 ((UINT4 *)pHash[7])
#define udigest9 ((UINT4 *)pHash[8])
#define udigest10 ((UINT4 *)pHash[9])
#define udigest11 ((UINT4 *)pHash[10])
#define udigest12 ((UINT4 *)pHash[11])
#define udigest13 ((UINT4 *)pHash[12])
#define udigest14 ((UINT4 *)pHash[13])
#define udigest15 ((UINT4 *)pHash[14])
#define udigest16 ((UINT4 *)pHash[15])


#define _mm_extract_epi32(x, imm) \
	_mm_cvtsi128_si32(_mm_srli_si128((x), 4 * (imm)))

// unroll the loop
// pass one: i=0, j=3
    i=0;
    udigest1[0] = _mm_extract_epi32(a, 3);
    udigest1[1] = _mm_extract_epi32(b, 3);
    udigest1[2] = _mm_extract_epi32(c, 3);
    udigest1[3] = _mm_extract_epi32(d, 3);
    udigest5[0] = _mm_extract_epi32(a2, 3); 
    udigest5[1] = _mm_extract_epi32(b2, 3);  
    udigest5[2] = _mm_extract_epi32(c2, 3);  
    udigest5[3] = _mm_extract_epi32(d2, 3);  
    udigest9[0] = _mm_extract_epi32(a3, 3);  
    udigest9[1] = _mm_extract_epi32(b3, 3);  
    udigest9[2] = _mm_extract_epi32(c3, 3);  
    udigest9[3] = _mm_extract_epi32(d3, 3);  
    udigest13[0] = _mm_extract_epi32(a4, 3);  
    udigest13[1] = _mm_extract_epi32(b4, 3);  
    udigest13[2] = _mm_extract_epi32(c4, 3);  
    udigest13[3] = _mm_extract_epi32(d4, 3);  

// pass two: i=1, j=2
    i=1;
    udigest2[0] = _mm_extract_epi32(a, 2);
    udigest2[1] = _mm_extract_epi32(b, 2);
    udigest2[2] = _mm_extract_epi32(c, 2);
    udigest2[3] = _mm_extract_epi32(d, 2);
    udigest6[0] = _mm_extract_epi32(a2, 2); 
    udigest6[1] = _mm_extract_epi32(b2, 2);  
    udigest6[2] = _mm_extract_epi32(c2, 2);  
    udigest6[3] = _mm_extract_epi32(d2, 2);  
    udigest10[0] = _mm_extract_epi32(a3, 2);  
    udigest10[1] = _mm_extract_epi32(b3, 2);  
    udigest10[2] = _mm_extract_epi32(c3, 2);  
    udigest10[3] = _mm_extract_epi32(d3, 2);  
    udigest14[0] = _mm_extract_epi32(a4, 2);  
    udigest14[1] = _mm_extract_epi32(b4, 2);  
    udigest14[2] = _mm_extract_epi32(c4, 2);  
    udigest14[3] = _mm_extract_epi32(d4, 2);  

// pass three: i=2, j=1
    i=2;
    udigest3[0] = _mm_extract_epi32(a, 1);
    udigest3[1] = _mm_extract_epi32(b, 1);
    udigest3[2] = _mm_extract_epi32(c, 1);
    udigest3[3] = _mm_extract_epi32(d, 1);
    udigest7[0] = _mm_extract_epi32(a2, 1); 
    udigest7[1] = _mm_extract_epi32(b2, 1);  
    udigest7[2] = _mm_extract_epi32(c2, 1);  
    udigest7[3] = _mm_extract_epi32(d2, 1);  
    udigest11[0] = _mm_extract_epi32(a3, 1);  
    udigest11[1] = _mm_extract_epi32(b3, 1);  
    udigest11[2] = _mm_extract_epi32(c3, 1);  
    udigest11[3] = _mm_extract_epi32(d3, 1);  
    udigest15[0] = _mm_extract_epi32(a4, 1);  
    udigest15[1] = _mm_extract_epi32(b4, 1);  
    udigest15[2] = _mm_extract_epi32(c4, 1);  
    udigest15[3] = _mm_extract_epi32(d4, 1);  


// pass four: i=3, j=0
    i=3;
    udigest4[0] = _mm_extract_epi32(a, 0);
    udigest4[1] = _mm_extract_epi32(b, 0);
    udigest4[2] = _mm_extract_epi32(c, 0);
    udigest4[3] = _mm_extract_epi32(d, 0);
    udigest8[0] = _mm_extract_epi32(a2, 0); 
    udigest8[1] = _mm_extract_epi32(b2, 0);  
    udigest8[2] = _mm_extract_epi32(c2, 0);  
    udigest8[3] = _mm_extract_epi32(d2, 0);  
    udigest12[0] = _mm_extract_epi32(a3, 0);  
    udigest12[1] = _mm_extract_epi32(b3, 0);  
    udigest12[2] = _mm_extract_epi32(c3, 0);  
    udigest12[3] = _mm_extract_epi32(d3, 0);  
    udigest16[0] = _mm_extract_epi32(a4, 0);  
    udigest16[1] = _mm_extract_epi32(b4, 0);  
    udigest16[2] = _mm_extract_epi32(c4, 0);  
    udigest16[3] = _mm_extract_epi32(d4, 0);  

// Revert zeros
    for (i = 0; i < SSE_SIMULTANEOUS; i++)
    {
	*(pPlain[i]+nPlainLen[i])=0x00;
    }
}


void MD5_SSE_SHORT(unsigned char* pPlain[SSE_SIMULTANEOUS], int nPlainLen[SSE_SIMULTANEOUS], unsigned char* pHash[SSE_SIMULTANEOUS])
{
    __m128i mAC1 = _mm_set1_epi32(0xd76aa478);
    __m128i mAC2 = _mm_set1_epi32(0xe8c7b756);
    __m128i mAC3 = _mm_set1_epi32(0x242070db);
    __m128i mAC4 = _mm_set1_epi32(0xc1bdceee);
    __m128i mAC5 = _mm_set1_epi32(0xf57c0faf);
    __m128i mAC6 = _mm_set1_epi32(0x4787c62a);
    __m128i mAC7 = _mm_set1_epi32(0xa8304613);
    __m128i mAC8 = _mm_set1_epi32(0xfd469501);
    __m128i mAC9 = _mm_set1_epi32(0x698098d8);
    __m128i mAC10 = _mm_set1_epi32(0x8b44f7af);
    __m128i mAC11 = _mm_set1_epi32(0xffff5bb1);
    __m128i mAC12 = _mm_set1_epi32(0x895cd7be);
    __m128i mAC13 = _mm_set1_epi32(0x6b901122);
    __m128i mAC14 = _mm_set1_epi32(0xfd987193);
    __m128i mAC15 = _mm_set1_epi32(0xa679438e);
    __m128i mAC16 = _mm_set1_epi32(0x49b40821);
    __m128i mAC17 = _mm_set1_epi32(0xf61e2562);
    __m128i mAC18 = _mm_set1_epi32(0xc040b340);
    __m128i mAC19 = _mm_set1_epi32(0x265e5a51);
    __m128i mAC20 = _mm_set1_epi32(0xe9b6c7aa);
    __m128i mAC21 = _mm_set1_epi32(0xd62f105d);
    __m128i mAC22 = _mm_set1_epi32(0x02441453);
    __m128i mAC23 = _mm_set1_epi32(0xd8a1e681);
    __m128i mAC24 = _mm_set1_epi32(0xe7d3fbc8);
    __m128i mAC25 = _mm_set1_epi32(0x21e1cde6);
    __m128i mAC26 = _mm_set1_epi32(0xc33707d6);
    __m128i mAC27 = _mm_set1_epi32(0xf4d50d87);
    __m128i mAC28 = _mm_set1_epi32(0x455a14ed);
    __m128i mAC29 = _mm_set1_epi32(0xa9e3e905);
    __m128i mAC30 = _mm_set1_epi32(0xfcefa3f8);
    __m128i mAC31 = _mm_set1_epi32(0x676f02d9);
    __m128i mAC32 = _mm_set1_epi32(0x8d2a4c8a);
    __m128i mAC33 = _mm_set1_epi32(0xfffa3942);
    __m128i mAC34 = _mm_set1_epi32(0x8771f681);
    __m128i mAC35 = _mm_set1_epi32(0x6d9d6122);
    __m128i mAC36 = _mm_set1_epi32(0xfde5380c);
    __m128i mAC37 = _mm_set1_epi32(0xa4beea44);
    __m128i mAC38 = _mm_set1_epi32(0x4bdecfa9);
    __m128i mAC39 = _mm_set1_epi32(0xf6bb4b60);
    __m128i mAC40 = _mm_set1_epi32(0xbebfbc70);
    __m128i mAC41 = _mm_set1_epi32(0x289b7ec6);
    __m128i mAC42 = _mm_set1_epi32(0xeaa127fa);
    __m128i mAC43 = _mm_set1_epi32(0xd4ef3085);
    __m128i mAC44 = _mm_set1_epi32(0x04881d05);
    __m128i mAC45 = _mm_set1_epi32(0xd9d4d039);
    __m128i mAC46 = _mm_set1_epi32(0xe6db99e5);
    __m128i mAC47 = _mm_set1_epi32(0x1fa27cf8);
    __m128i mAC48 = _mm_set1_epi32(0xc4ac5665);
    __m128i mAC49 = _mm_set1_epi32(0xf4292244);
    __m128i mAC50 = _mm_set1_epi32(0x432aff97);
    __m128i mAC51 = _mm_set1_epi32(0xab9423a7);
    __m128i mAC52 = _mm_set1_epi32(0xfc93a039);
    __m128i mAC53 = _mm_set1_epi32(0x655b59c3);
    __m128i mAC54 = _mm_set1_epi32(0x8f0ccc92);
    __m128i mAC55 = _mm_set1_epi32(0xffeff47d);
    __m128i mAC56 = _mm_set1_epi32(0x85845dd1);
    __m128i mAC57 = _mm_set1_epi32(0x6fa87e4f);
    __m128i mAC58 = _mm_set1_epi32(0xfe2ce6e0);
    __m128i mAC59 = _mm_set1_epi32(0xa3014314);
    __m128i mAC60 = _mm_set1_epi32(0x4e0811a1);
    __m128i mAC61 = _mm_set1_epi32(0xf7537e82);
    __m128i mAC62 = _mm_set1_epi32(0xbd3af235);
    __m128i mAC63 = _mm_set1_epi32(0x2ad7d2bb);
    __m128i mAC64 = _mm_set1_epi32(0xeb86d391);

    __m128i mOne = _mm_set1_epi32(0xFFFFFFFF);

    __m128i mCa = _mm_set1_epi32(Ca);
    __m128i mCb = _mm_set1_epi32(Cb);
    __m128i mCc = _mm_set1_epi32(Cc);
    __m128i mCd = _mm_set1_epi32(Cd);


    __m128i w0_1, w0_2, w0_3, w1_1, w1_2, w1_3, w2_1, w2_2, w2_3, w3_1, w3_2, w3_3, w14_1, w14_2, w14_3;
    __m128i w4_1, w4_2, w4_3, w5_1, w5_2, w5_3, w6_1, w6_2, w6_3, w7_1, w7_2, w7_3;
    __m128i w8_1, w8_2, w8_3, w9_1, w9_2, w9_3, w10_1, w10_2, w10_3;
    __m128i w0_4, w1_4, w2_4, w3_4, w4_4, w14_4;


    __m128i a, b, c, d, tmp1;
    __m128i a2, b2, c2, d2, tmp1_2;
    __m128i a3, b3, c3, d3, tmp1_3;
    __m128i a4, b4, c4, d4, tmp1_4;


    int i;
    char *tst;
    for (i = 0; i < SSE_SIMULTANEOUS; i++)
    {
	*(pPlain[i]+nPlainLen[i])=0x80;
    }


    w0_1 = _mm_set_epi32(udata1[0], udata2[0], udata3[0], udata4[0]);
    w0_2 = _mm_set_epi32(udata5[0], udata6[0], udata7[0], udata8[0]);
    w0_3 = _mm_set_epi32(udata9[0], udata10[0], udata11[0], udata12[0]);
    w0_4 = _mm_set_epi32(udata13[0], udata14[0], udata15[0], udata16[0]);

    w1_1 = _mm_set_epi32(udata1[1], udata2[1], udata3[1], udata4[1]);
    w1_2 = _mm_set_epi32(udata5[1], udata6[1], udata7[1], udata8[1]);
    w1_3 = _mm_set_epi32(udata9[1], udata10[1], udata11[1], udata12[1]);
    w1_4 = _mm_set_epi32(udata13[1], udata14[1], udata15[1], udata16[1]);

    w2_1 = _mm_set_epi32(udata1[2], udata2[2], udata3[2], udata4[2]);
    w2_2 = _mm_set_epi32(udata5[2], udata6[2], udata7[2], udata8[2]);
    w2_3 = _mm_set_epi32(udata9[2], udata10[2], udata11[2], udata12[2]);
    w2_4 = _mm_set_epi32(udata13[2], udata14[2], udata15[2], udata16[2]);

    w3_1 = _mm_set_epi32(udata1[3], udata2[3], udata3[3], udata4[3]);
    w3_2 = _mm_set_epi32(udata5[3], udata6[3], udata7[3], udata8[3]);
    w3_3 = _mm_set_epi32(udata9[3], udata10[3], udata11[3], udata12[3]);
    w3_4 = _mm_set_epi32(udata13[3], udata14[3], udata15[3], udata16[3]);

    w14_1 = _mm_set_epi32(nPlainLen[0]*8, nPlainLen[1]*8, nPlainLen[2]*8, nPlainLen[3]*8);
    w14_2 = _mm_set_epi32(nPlainLen[4]*8, nPlainLen[5]*8, nPlainLen[6]*8, nPlainLen[7]*8);
    w14_3 = _mm_set_epi32(nPlainLen[8]*8, nPlainLen[9]*8, nPlainLen[10]*8, nPlainLen[11]*8);
    w14_4 = _mm_set_epi32(nPlainLen[12]*8, nPlainLen[13]*8, nPlainLen[14]*8, nPlainLen[15]*8);


    a = mCa;
    a2 = mCa;
    a3 = mCa;
    a4 = mCa;

    b = mCb;
    b2 = mCb;
    b3 = mCb;
    b4 = mCb;

    c = mCc;
    c2 = mCc;
    c3 = mCc;
    c4 = mCc;

    d = mCd;
    d2 = mCd;
    d3 = mCd;
    d4 = mCd;

    MD5_STEPS_SHORT();

    a = _mm_add_epi32(a,mCa);
    a2 =  _mm_add_epi32(a2,mCa);
    a3 =  _mm_add_epi32(a3,mCa);
    a4 =  _mm_add_epi32(a4,mCa);

    b =  _mm_add_epi32(b,mCb);
    b2 = _mm_add_epi32(b2,mCb);
    b3 = _mm_add_epi32(b3,mCb);
    b4 = _mm_add_epi32(b4,mCb);

    c =  _mm_add_epi32(c,mCc);
    c2 = _mm_add_epi32(c2,mCc);
    c3 =  _mm_add_epi32(c3,mCc);
    c4 =  _mm_add_epi32(c4,mCc);

    d =  _mm_add_epi32(d,mCd);
    d2 =  _mm_add_epi32(d2,mCd);
    d3 =  _mm_add_epi32(d3,mCd);
    d4 =  _mm_add_epi32(d4,mCd);

#define uDigest ((UINT4 *)pHash)
#define NEXT_HASH (MAX_HASH_LEN/4)
#define udigest1 ((UINT4 *)pHash[0])
#define udigest2 ((UINT4 *)pHash[1])
#define udigest3 ((UINT4 *)pHash[2])
#define udigest4 ((UINT4 *)pHash[3])
#define udigest5 ((UINT4 *)pHash[4])
#define udigest6 ((UINT4 *)pHash[5])
#define udigest7 ((UINT4 *)pHash[6])
#define udigest8 ((UINT4 *)pHash[7])
#define udigest9 ((UINT4 *)pHash[8])
#define udigest10 ((UINT4 *)pHash[9])
#define udigest11 ((UINT4 *)pHash[10])
#define udigest12 ((UINT4 *)pHash[11])
#define udigest13 ((UINT4 *)pHash[12])
#define udigest14 ((UINT4 *)pHash[13])
#define udigest15 ((UINT4 *)pHash[14])
#define udigest16 ((UINT4 *)pHash[15])


#define _mm_extract_epi32(x, imm) \
	_mm_cvtsi128_si32(_mm_srli_si128((x), 4 * (imm)))

// unroll the loop
// pass one: i=0, j=3
    i=0;
    udigest1[0] = _mm_extract_epi32(a, 3);
    udigest1[1] = _mm_extract_epi32(b, 3);
    udigest1[2] = _mm_extract_epi32(c, 3);
    udigest1[3] = _mm_extract_epi32(d, 3);
    udigest5[0] = _mm_extract_epi32(a2, 3); 
    udigest5[1] = _mm_extract_epi32(b2, 3);  
    udigest5[2] = _mm_extract_epi32(c2, 3);  
    udigest5[3] = _mm_extract_epi32(d2, 3);  
    udigest9[0] = _mm_extract_epi32(a3, 3);  
    udigest9[1] = _mm_extract_epi32(b3, 3);  
    udigest9[2] = _mm_extract_epi32(c3, 3);  
    udigest9[3] = _mm_extract_epi32(d3, 3);  
    udigest13[0] = _mm_extract_epi32(a4, 3);  
    udigest13[1] = _mm_extract_epi32(b4, 3);  
    udigest13[2] = _mm_extract_epi32(c4, 3);  
    udigest13[3] = _mm_extract_epi32(d4, 3);  

// pass two: i=1, j=2
    i=1;
    udigest2[0] = _mm_extract_epi32(a, 2);
    udigest2[1] = _mm_extract_epi32(b, 2);
    udigest2[2] = _mm_extract_epi32(c, 2);
    udigest2[3] = _mm_extract_epi32(d, 2);
    udigest6[0] = _mm_extract_epi32(a2, 2); 
    udigest6[1] = _mm_extract_epi32(b2, 2);  
    udigest6[2] = _mm_extract_epi32(c2, 2);  
    udigest6[3] = _mm_extract_epi32(d2, 2);  
    udigest10[0] = _mm_extract_epi32(a3, 2);  
    udigest10[1] = _mm_extract_epi32(b3, 2);  
    udigest10[2] = _mm_extract_epi32(c3, 2);  
    udigest10[3] = _mm_extract_epi32(d3, 2);  
    udigest14[0] = _mm_extract_epi32(a4, 2);  
    udigest14[1] = _mm_extract_epi32(b4, 2);  
    udigest14[2] = _mm_extract_epi32(c4, 2);  
    udigest14[3] = _mm_extract_epi32(d4, 2);  

// pass three: i=2, j=1
    i=2;
    udigest3[0] = _mm_extract_epi32(a, 1);
    udigest3[1] = _mm_extract_epi32(b, 1);
    udigest3[2] = _mm_extract_epi32(c, 1);
    udigest3[3] = _mm_extract_epi32(d, 1);
    udigest7[0] = _mm_extract_epi32(a2, 1); 
    udigest7[1] = _mm_extract_epi32(b2, 1);  
    udigest7[2] = _mm_extract_epi32(c2, 1);  
    udigest7[3] = _mm_extract_epi32(d2, 1);  
    udigest11[0] = _mm_extract_epi32(a3, 1);  
    udigest11[1] = _mm_extract_epi32(b3, 1);  
    udigest11[2] = _mm_extract_epi32(c3, 1);  
    udigest11[3] = _mm_extract_epi32(d3, 1);  
    udigest15[0] = _mm_extract_epi32(a4, 1);  
    udigest15[1] = _mm_extract_epi32(b4, 1);  
    udigest15[2] = _mm_extract_epi32(c4, 1);  
    udigest15[3] = _mm_extract_epi32(d4, 1);  

// pass four: i=3, j=0
    i=3;
    udigest4[0] = _mm_extract_epi32(a, 0);
    udigest4[1] = _mm_extract_epi32(b, 0);
    udigest4[2] = _mm_extract_epi32(c, 0);
    udigest4[3] = _mm_extract_epi32(d, 0);
    udigest8[0] = _mm_extract_epi32(a2, 0); 
    udigest8[1] = _mm_extract_epi32(b2, 0);  
    udigest8[2] = _mm_extract_epi32(c2, 0);  
    udigest8[3] = _mm_extract_epi32(d2, 0);  
    udigest12[0] = _mm_extract_epi32(a3, 0);  
    udigest12[1] = _mm_extract_epi32(b3, 0);  
    udigest12[2] = _mm_extract_epi32(c3, 0);  
    udigest12[3] = _mm_extract_epi32(d3, 0);  
    udigest16[0] = _mm_extract_epi32(a4, 0);  
    udigest16[1] = _mm_extract_epi32(b4, 0);  
    udigest16[2] = _mm_extract_epi32(c4, 0);  
    udigest16[3] = _mm_extract_epi32(d4, 0);  

// Revert zeros
    for (i = 0; i < SSE_SIMULTANEOUS; i++)
    {
	*(pPlain[i]+nPlainLen[i])=0x00;
    }
}


#endif
